import React, { Component } from 'react';
import { Canvas, Text, View } from '@tarojs/components';
import { createCanvasContext, getSystemInfoSync } from '@tarojs/taro';
import './index.less';

export default class ProgresCanvas extends Component {
  constructor(props) {
    super(props);
  }

  facilCanvas (id, dp, color) {
    let query = createCanvasContext(id);
    const drawArc = (s, e) => {

      /*
          * x：X轴绘制点
          * y: y轴绘制点
          * 通过x,y轴绘制点来控制你画的弧形进度条位置
      */

      let x = 98 * dp, y = 102 * dp, radius = 94 * dp;
      query.setFillStyle('#cdcdcd');
      query.clearRect(0, 0, 200, 200);
      query.draw();
      query.setLineWidth(8);
      query.setStrokeStyle(color);
      query.setLineCap('round');
      query.beginPath();
      query.arc(x, y, radius, s, e, false);
      query.stroke();
      query.draw();
    };

    /*
        * step : 个数据
        * n：总数据
        * 最终通过 step和n之间的比值来绘制进度
    */
    let step = 20, n = 60, startAngle = 1.5 * Math.PI, endAngle = 0;
    endAngle = step * 2 * Math.PI / n + 1.5 * Math.PI;
    drawArc(startAngle, endAngle);
  };

  componentDidMount() {
    let facility = getSystemInfoSync(); // 获取设备信息
    let facility_width = facility.windowWidth; // 设备宽度
    let dpr = facility_width / 750;

    this.facilCanvas('visitor_canvas', dpr, '#d81e06'); // 客访次数
  }

  render() {
    return (
      <View>
        <Canvas className="visitor_middle_circle" canvasId="visitor_canvas"></Canvas>
      </View>
    );
  }
}
