import React,{Component} from 'react';
import Taro from '@tarojs/taro';
import {Text, View} from '@tarojs/components'
import moment from 'moment';

import WPicker from '../../components/common/wPicker'
import ImagePicker from '../../components/common/imagePicker'

import { AtButton,AtTextarea ,AtIcon,AtCalendar   } from 'taro-ui'
import {addPublicRelease} from '../../utils/servers/servers';

import 'taro-ui/dist/style/components/form.scss';
import 'taro-ui/dist/style/components/button.scss';
import 'taro-ui/dist/style/components/loading.scss';
import 'taro-ui/dist/style/components/icon.scss';
import 'taro-ui/dist/style/components/icon.scss';
import 'taro-ui/dist/style/components/textarea.scss';
import 'taro-ui/dist/style/components/calendar.scss';

import './publicContent.less';

class PublicContent extends Component{
  constructor(props) {
    super(props);
    this.state={
      rangeVal:[],
      selectArrderName:'',
      reason:'',
      imgs:[],
      validDates:[
        { value: '2021/6/3' },
        { value: '2021/6/4' },
        { value: '2021/6/5' },
        { value: '2021/6/6' },
        { value: '2021/6/7' },
        { value: '2021/6/8' },
        { value: '2021/6/9' },
        { value: '2021/6/10' },
      ]
    }
    this.onSubmit = this.onSubmit.bind(this);
    this.selectArrder = this.selectArrder.bind(this);
    this.onChange = this.onChange.bind(this);
    this.WPicker = null
  }
  componentDidShow() {

  }

  onSubmit(){
    // if(this.state.imgs.length === 0){
    //   Taro.showToast({title:'',icon:'none'})
    //   return ;
    // }
    let annexUrl = '';
    for(let i of this.state.imgs){
      annexUrl+=','+i;
    }
    addPublicRelease({
      uid:this.props.enterpriseInfor.id,
      releaseStarts:this.state.rangeVal[0],
      releaseEnds:this.state.rangeVal[1],
      remarks:this.state.reason,
      userName: this.props.selectArrderLocation.name,
      longitude: this.props.selectArrderLocation.longitude,
      latitude: this.props.selectArrderLocation.latitude,
      annexUrl: annexUrl || undefined
    });
  }

  selectArrder(){
    const key = 'AWBBZ-GRAC2-JFYUO-CLA7I-JAHXK-YFFGT'; //使用在腾讯位置服务申请的key
    const referer = '科德打卡定位'; //调用插件的app的名称
    const location = JSON.stringify({
      latitude: 39.89631551,
      longitude: 116.323459711
    });
    const category = '生活服务,娱乐休闲';

    Taro.navigateTo({
      url: 'plugin://chooseLocation/index?key=' + key + '&referer=' + referer + '&location=' + location + '&category=' + category
    });
  }

  onChange(value,type){
    let arr = this.state.imgs.concat([]);
    if(type === 'add'){
      arr.push(value)
    }else if(type === 'remove'){
      arr.splice(value,1)
    }
    this.setState({
      imgs: arr
    })
    console.log(arr,type)
  }

  render() {
    return (
      <View className='publicContent'>
        <WPicker
          mode='range'
          value={this.state.rangeVal}
          current
          confirm={(e)=>{
            this.setState({
              rangeVal:e.value.split('至')
            })
            console.log(e)
          }}
          cancel={()=>{

          }}
          disabledAfter={false}
          onRef={(ref)=>{this.WPicker = ref}}/>
          <View className='formItem'>
            <View className='formName'>外出企业:</View>
            <View className='formValue'>{this.props.enterpriseInfor.name}</View>
          </View>
        <View className='formItem'>
          <View className='formName'>公出时间:</View>
          <View className='formValue' onClick={()=>{this.WPicker.show()}}>
            {this.state.rangeVal.join('至')}
            <AtIcon value='chevron-right' size='30' color='#bbbbbb'/>
          </View>
        </View>
        <View className='formItem' style={{display:'block',paddingTop:'15px'}}>
          <View className='formName'>公出日期:</View>
          <AtCalendar
            minDate='2021/6/3'
            maxDate='2021/6/10'
            isSwiper={false}
            validDates={this.state.validDates}
            onDayLongClick={(item)=>{
              console.log(item)
              let index = this.state.validDates.findIndex(v=>{
                let lv = moment(v.value.split('/')).isSame(item.value.split('-'));
                return lv
              })
              if(index<0){
                console.log(item,'console.log(item)')
                let arr = item.value.split('-');
                this.state.validDates.push(arr.join('/'))
                this.setState({
                  validDates:this.state.validDates
                })
              }else{
                this.state.validDates.splice(index,1)
                this.setState({
                  validDates:this.state.validDates
                })
              }
            }}
          />
        </View>
        <View className='formItem'>
          <View className='formName'>公出地点:</View>
          <View className='formValue' onClick={this.selectArrder}>
              <Text className='formValueText'>{this.props.selectArrderLocation.name}</Text>
              <AtIcon value='chevron-right' size='30' color='#bbbbbb'/>
          </View>
        </View>
        <View className='tips'>地址选择错误,将影响打卡定位,选择后请认真核对</View>
        <View className='formItem' style={{display:'block',paddingTop:'15px'}}>
          <View className='formName'>公出事由:</View>
          <View className='formValue' style={{paddingTop:'10px',textAlign:'left'}}>
            <AtTextarea
              value={this.state.reason}
              onChange={(v)=>{
                this.setState({
                  reason:v
                })
              }}
              maxLength={200}
              placeholder='请输入公出事由'
            />
          </View>
        </View>
        <View className='formItem' style={{display:'block'}}>
          <View className='formName'>附件:</View>
          <View className='formValue' style={{paddingTop:'10px',textAlign:'left'}}>
            <ImagePicker
              url='/api/admin/release/upload'
              onChange={this.onChange}
            />
          </View>
        </View>
        <View className='operation'>
          <AtButton type='secondary' circle onClick={()=>{
            Taro.eventCenter.trigger('enterpriseBack')
          }}>
            上一步
          </AtButton>
          <AtButton type='primary' circle onClick={this.onSubmit}>
            提交申请
          </AtButton>
        </View>
      </View>
    )
  }
}

export default PublicContent;
